#include "CAnimation.h"
#include "Config.h"

CAnimation::CAnimation()
{
	m_typeID = ID::COMPONENT::ANIMATION;
	m_visible = true;
	m_animate.clear();
}

CAnimation::~CAnimation()
{
	m_animate.clear();
}

CAnimation* CAnimation::addComponentTo(Entity* object, const char* resourcePath)
{
	// BASIC INIT FOR ANY TYPE OF COMPONENT
	CAnimation* result = new CAnimation();
	object->addComponent(result);
	result->m_owner = object;

	// SPECIAL INIT FOR THIS TYPE OF COMPONENT
	result->m_animate.push_back(new FTexture(resourcePath));
	result->m_currentAnimationIndex = 0;

	return result;
}

int CAnimation::update(float deltaTime)
{
	return 0;
}

int CAnimation::commandProcess(int command)
{
	switch (command)
	{
	case CAnimation::COMMAND::HIDE:
		m_visible = false;
		break;

	case CAnimation::COMMAND::SHOW:
		m_visible = true;
		break;

		// Other commands

	default:
		break;
	}
	return 0;
}

int CAnimation::draw(HDC hdc)
{
	if (m_visible)
	{
		m_animate.at(m_currentAnimationIndex)->draw(hdc);
	}
	return 0;
}