#ifndef __CANIMATION_H__
#define __CANIMATION_H__

#include "FTexture.h"

#include "Entity.h"
#include "CBase.h"

#include <vector>

class CAnimation : public CBase
{
public:
	enum COMMAND
	{
		CHANGE_ANIMATION = 0,
		FACE_LEFT,
		FACE_RIGHT,
		SHOW,
		HIDE
	};

	static CAnimation* addComponentTo(Entity* object, const char* resourcePath);

	virtual int update(float deltaTime);
	virtual int commandProcess(int command);

	int draw(HDC hdc);

private:
	CAnimation();
	~CAnimation();

private:
	vector<FTexture*>	m_animate;
	unsigned int		m_currentAnimationIndex;
	bool				m_visible;
};
#endif // __CANIMATION_H__