#include "Entity.h"
#include "Config.h"
#include "CAnimation.h"

Entity::Entity()
{

}

Entity::~Entity()
{

}

int Entity::update(float delta)
{
	for (CBase* component : m_components)
		component->update(delta);

	// TEST CODE

	static float s_timer = 0.0f;
	s_timer += delta;
	if (s_timer >= 1.0f)
	{
		m_components.at(0)->commandProcess(CAnimation::COMMAND::HIDE);
	}

	if (s_timer >= 2.0f)
	{
		m_components.at(0)->commandProcess(CAnimation::COMMAND::SHOW);
		s_timer = 0.0f;
	}

	// ===========================

	return 0;
}

void Entity::draw(HDC hdc)
{
	for (CBase* component : m_components)
	{
		if (component->getTypeID() == ID::COMPONENT::ANIMATION)
		{
			((CAnimation*)component)->draw(hdc);
			break;
		}
	}
}

void Entity::addComponent(CBase* component)
{
	m_components.push_back(component);
}
