#include "stdafx.h"
#include "FWindows.h"
#include "FTexture.h"

#include "Entity.h"
#include "CAnimation.h"

void init(HINSTANCE instance, HWND handler);
void release();
void update(float delta);
void draw(HDC hdc);

Entity* g_entity;

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
	_In_opt_ HINSTANCE hPrevInstance,
	_In_ LPTSTR    lpCmdLine,
	_In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	FWindows window(hInstance, nCmdShow, 500, 500, &update, &draw);

	init(hInstance, window.getHandler());

	window.run();
	
	release();

	return 0;
}

// UPDATE REGION
void update(float delta)
{
	g_entity->update(delta);
}

// DRAW REGION
void draw(HDC hdc)
{
	g_entity->draw(hdc);
}

void init(HINSTANCE instance, HWND handler)
{
	FTexture::init(instance, handler);

	g_entity = new Entity();
	CAnimation::addComponentTo(g_entity, "Resource\\logo.bmp");
}

void release()
{
	FTexture::release();

	delete(g_entity);
}
